// i8014W_ReadAI_Average_Cplusplus.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "..\Lib\pac_i8014W.h"
#pragma comment(lib,"..\\Lib\\pac_i8014W.lib")

int slotIndex=-1;
char GainStr[5][32]={"+/-10V","+/-5V","+/-2.5V","+/-1.25V","+/-20mA"};

int _tmain(int argc, _TCHAR* argv[])
{
	int i=0;
	int ret=0;
	int slot=0;
	int jumper=0;
	int maxCh=0;
	int gain=0;
	float sampleRate=0;
	int avglevel=0;
	char libDate[20];
	float *fVal;
	int total=0;
	int reflash_ms=0;
	int average_cnt[7]={1,2,4,8,16,32,256};

	printf("\n\n This Demo will shows users how to use Average functions to read analog input\n\n");
	printf("  STEP1 : Search and initialize I-8014W series modules\n");
	for(slot=0;slot<8;slot++){
		if(pac_i8014W_Init(slot)==0){ //find I-8014W series module out
			slotIndex=slot;
			printf("  There is an  I-8014W/I-8014CW/I-9014/I-9014C at slot %d\n",slotIndex);
			break;
		}
	}
	if(slotIndex==-1){
		printf("  There is no I-8014W/I-8014CW/I-9014/I-9014C at Backplane\n");
		Sleep(100);
		exit(0);
	}

	printf("  Librart Version : %X \n",pac_i8014W_GetLibVersion());
	pac_i8014W_GetLibDate(libDate);
	printf("  Librart date : %s \n",libDate);
	printf("  Firmware 1 Version : %d \n",pac_i8014W_GetFirmwareVer_L1(slotIndex));
	printf("  Firmware 2 Version : %d \n",pac_i8014W_GetFirmwareVer_L2(slotIndex));
	
	jumper=pac_i8014W_GetSingleEndJumper(slotIndex);
	if(jumper){
		maxCh=16;
		fVal=new float[16];
		printf("  Jumper position = Single-Ende( 16 analog input channels max )\n\r");
	}
	else{
		maxCh=8;
		fVal=new float[8];
		printf("  Jumper position = Differential( 8 analog input channels max)\n\r");
	}

	printf("  STEP2 : Input all the parameters to configure average function\n");
	printf ("    Select input range \n");
	for(i=0;i<5;i++){
    	printf ("    %d :  %s",i,GainStr[i]);
    }
	scanf("%d", &gain);

	printf ("    Input Sample rate\n");
	printf ("    For differential : 1 ~ 5000 Hz\n");
	printf ("    For single-ended : 1 ~ 2500 Hz\n");
    scanf("%f",&sampleRate);

	printf ("    Select the level of average number of data count\n");
	printf ("    level 0 : Calculate average for every 1 data\n");
	printf ("    level 1 : Calculate average for every 2 data\n");
	printf ("    level 2 : Calculate average for every 4 data\n");
	printf ("    level 3 : Calculate average for every 8 data\n");
	printf ("    level 4 : Calculate average for every 16 data\n");
	printf ("    level 5 : Calculate average for every 32 data\n");
	printf ("    level 6 : Calculate average for every 64 data\n");
	printf ("    level 7 : Calculate average for every 256 data\n");
    scanf("%f",&avglevel);

	//Start Average function
	ret=pac_i8014W_Start_Average_INT(slotIndex,gain,sampleRate,avglevel);
	if(ret==0 || ret==1){
		printf("    Start successed!!\n");
	}

	//Data refresh frequency : 1/sample rate * average count
	//for example, 1000 Hz, Average count 64 ==> 1ms * 64 = about 64ms
	reflash_ms=(float)((float)1000/sampleRate)*average_cnt[avglevel];
	while(total<400){
		pac_i8014W_ReadAllAI_Average_INT(slotIndex,fVal);
		total+=maxCh;
		Sleep(reflash_ms);
		for(i=0;i<maxCh;++i){
			printf("[%2d:%6.3f] ",i,fVal[i]);
		}
		printf("\n");
	}
	
	//Stop Average function
	pac_i8014W_Stop_Average_INT(slotIndex);
	getchar();
	getchar();
	return 0;
}